/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.35 Revision 1.79
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.35 2009/04/15 11:09:50 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.79 2010/12/06 10:17:04 tampakrap Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but 13# NOTE: KDE 4 ebuilds by default define EAPI="2", this can be redefined but
14# eclass will fail with version older than 2. 14# eclass will fail with version older than 2.
15 15
16inherit base cmake-utils eutils kde4-functions 16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION:
18# Do we need an X server? Valid values are "always", "optional", and "manual".
19# "tests" is a synonym for "optional". While virtualx.eclass supports in principle
20# also the use of an X server during other ebuild phases, we only use it in
21# src_test here. Most likely you'll want to set "optional", which introduces the
22# use-flag "test" (if not already present), adds dependencies conditional on that
23# use-flag, and automatically runs (only) the ebuild test phase with a virtual X server
24# present. This makes things a lot more comfortable than the bare virtualx eclass.
25
26# In case the variable is not set in the ebuild, let virtualx eclass not do anything
27: ${VIRTUALX_REQUIRED:=manual}
28
29inherit kde4-functions base virtualx eutils
17 30
18get_build_type 31get_build_type
19if [[ ${BUILD_TYPE} = live ]]; then 32if [[ ${BUILD_TYPE} = live ]]; then
33 if [[ ${KDEBASE} = kdevelop ]]; then
34 inherit git
35 else
20 inherit subversion 36 inherit subversion
37 fi
21fi 38fi
22 39
23EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
24
25# @ECLASS-VARIABLE: OPENGL_REQUIRED
26# @DESCRIPTION:
27# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
28# This variable must be set before inheriting any eclasses. Defaults to 'never'.
29OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
30
31# @ECLASS-VARIABLE: WEBKIT_REQUIRED
32# @DESCRIPTION:
33# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
34# This variable must be set before inheriting any eclasses. Defaults to 'never'.
35WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
36
37# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
38# @DESCRIPTION:
39# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
40# This variable must be set before inheriting any eclasses. Defaults to 'never'.
41CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
42
43# @ECLASS-VARIABLE: KDE_REQUIRED 40# @ECLASS-VARIABLE: CMAKE_REQUIRED
44# @DESCRIPTION: 41# @DESCRIPTION:
45# Is kde required? Possible values are 'always', 'optional' and 'never'. 42# Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
46# This variable must be set before inheriting any eclasses. Defaults to 'always' 43# Please note that if it's set to 'never' you need to explicitly override following phases:
47# If set to always or optional, KDE_MINIMAL may be overriden as well. 44# src_configure, src_compile, src_test and src_install.
48# Note that for kde-base packages this variable is fixed to 'always'. 45# Defaults to 'always'.
49KDE_REQUIRED="${KDE_REQUIRED:-always}" 46: ${CMAKE_REQUIRED:=always}
47if [[ ${CMAKE_REQUIRED} = always ]]; then
48 buildsystem_eclass="cmake-utils"
49 export_fns="src_configure src_compile src_test src_install"
50fi
50 51
51# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here) 52# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
52if [[ -n ${KDE_MINIMAL} ]]; then 53if [[ -n ${KDE_MINIMAL} ]]; then
53 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do 54 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
54 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break 55 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
55 done 56 done
57 unset slot
56 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL 58 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
57else 59else
58 KDE_MINIMAL_VALID=1 60 KDE_MINIMAL_VALID=1
59fi 61fi
60 62
61# @ECLASS-VARIABLE: KDE_MINIMAL 63# @ECLASS-VARIABLE: KDE_MINIMAL
62# @DESCRIPTION: 64# @DESCRIPTION:
63# This wariable is used when KDE_REQUIRED is set, to specify required KDE minimal 65# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
64# version for apps to work. Currently defaults to 4.2 66# version for apps to work. Currently defaults to 4.4
65# One may override this variable to raise version requirements. 67# One may override this variable to raise version requirements.
66# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables. 68# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
67# Note that for kde-base packages is fixed to ${SLOT}. 69# Note that it is fixed to ${SLOT} for kde-base packages.
68KDE_MINIMAL="${KDE_MINIMAL:-4.2}" 70KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
69 71
70# Fallback behaviour (for now) 72# Set slot for packages in kde-base, koffice and kdevelop
71# TODO Remove when tree is clean 73case ${KDEBASE} in
72if [[ -n ${NEED_KDE} ]]; then 74 kde-base)
73 case ${NEED_KDE} in 75 # Determine SLOT from PVs
74 none) 76 case ${PV} in
75 KDE_REQUIRED="never" 77 *.9999*) SLOT="${PV/.9999*/}" ;; # stable live
76 ;; 78 4.6* | 4.5.[6-9][0-9]*) SLOT="4.6" ;;
77 *) 79 4.5* | 4.4.[6-9][0-9]*) SLOT="4.5" ;;
78 KDE_REQUIRED="always" 80 4.4* | 4.3.[6-9][0-9]*) SLOT="4.4" ;;
79 KDE_MINIMAL="${NEED_KDE}" 81 9999*) SLOT="live" ;; # regular live
80 ;; 82 *) die "Unsupported ${PV}" ;;
81 esac 83 esac
84 KDE_MINIMAL="${SLOT}"
85 ;;
86 koffice)
87 SLOT="2"
88 ;;
89 kdevelop)
90 if [[ ${BUILD_TYPE} = live ]]; then
91 # @ECLASS-VARIABLE: KDEVELOP_VERSION
92 # @DESCRIPTION:
93 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
94 # Applies to KDEBASE=kdevelop only.
95 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
96 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
97 # @DESCRIPTION:
98 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
99 # Applies to KDEBASE=kdevelop only.
100 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
101 else
102 case ${PN} in
103 kdevelop|quanta)
104 KDEVELOP_VERSION=${PV}
105 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
106 ;;
107 kdevplatform)
108 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
109 KDEVPLATFORM_VERSION=${PV}
110 ;;
111 *)
112 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
113 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
114 esac
115 fi
116 SLOT="4"
117 ;;
118esac
119
120slot_is_at_least 4.5 ${KDE_MINIMAL} && CMAKE_MIN_VERSION="2.8.1"
121
122inherit ${buildsystem_eclass}
123
124EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_postinst pkg_postrm
125
126unset buildsystem_eclass
127unset export_fns
128
129# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
130# @DESCRIPTION:
131# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
132# This variable must be set before inheriting any eclasses. Defaults to 'never'.
133DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
134
135# @ECLASS-VARIABLE: QTHELP_REQUIRED
136# @DESCRIPTION:
137# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
138# This variable must be set before inheriting any eclasses. Defaults to 'never'.
139QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
140
141# @ECLASS-VARIABLE: OPENGL_REQUIRED
142# @DESCRIPTION:
143# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
144# This variable must be set before inheriting any eclasses. Defaults to 'never'.
145OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
146
147# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
148# @DESCRIPTION:
149# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
150# This variable must be set before inheriting any eclasses. Defaults to 'never'.
151MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
152
153# @ECLASS-VARIABLE: WEBKIT_REQUIRED
154# @DESCRIPTION:
155# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
156# This variable must be set before inheriting any eclasses. Defaults to 'never'.
157WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
158
159# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
160# @DESCRIPTION:
161# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
162# This variable must be set before inheriting any eclasses. Defaults to 'never'.
163CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
164
165# @ECLASS-VARIABLE: KDE_REQUIRED
166# @DESCRIPTION:
167# Is kde required? Possible values are 'always', 'optional' and 'never'.
168# This variable must be set before inheriting any eclasses. Defaults to 'always'
169# If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
170# Note that for kde-base packages this variable is fixed to 'always'.
171KDE_REQUIRED="${KDE_REQUIRED:-always}"
172
173# @ECLASS-VARIABLE: KDE_HANDBOOK
174# @DESCRIPTION:
175# Set to enable handbook in application. Possible values are 'always', 'optional'
176# (handbook USE flag) and 'never'.
177# This variable must be set before inheriting any eclasses. Defaults to 'never'.
178# It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
179# ensures buildtime and runtime dependencies.
180KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
181
182# Setup packages inheriting this eclass
183case ${KDEBASE} in
184 kde-base)
185 HOMEPAGE="http://www.kde.org/"
186 LICENSE="GPL-2"
187 if [[ $BUILD_TYPE = live ]]; then
188 # Disable tests for live ebuilds
189 RESTRICT+=" test"
190 # Live ebuilds in kde-base default to kdeprefix by default
191 IUSE+=" +kdeprefix"
192 else
193 # All other ebuild types default to -kdeprefix as before
194 IUSE+=" kdeprefix"
195 fi
196 # This code is to prevent portage from searching GENTOO_MIRRORS for
197 # packages that will never be mirrored. (As they only will ever be in
198 # the overlay).
199 case ${PV} in
200 *9999* | 4.?.[6-9]?)
201 RESTRICT+=" mirror"
202 ;;
203 esac
204 # Block installation of other SLOTS unless kdeprefix
205 RDEPEND+=" $(block_other_slots)"
206 ;;
207 koffice)
208 HOMEPAGE="http://www.koffice.org/"
209 LICENSE="GPL-2"
210 ;;
211 kdevelop)
212 HOMEPAGE="http://www.kdevelop.org/"
213 LICENSE="GPL-2"
214 ;;
215esac
216
217# @ECLASS-VARIABLE: QT_MINIMAL
218# @DESCRIPTION:
219# Determine version of qt we enforce as minimal for the package. 4.4.0 4.5.1...
220# 4.6.0 for 4.4, 4.6.3 for 4.5, and 4.7.0 for 4.6 and later
221if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then
222 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
223elif slot_is_at_least 4.5 "${KDE_MINIMAL}"; then
224 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
225else
226 QT_MINIMAL="${QT_MINIMAL:-4.6.0}"
82fi 227fi
228
229# Declarative dependencies
230qtdeclarativedepend="
231 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
232"
233case ${DECLARATIVE_REQUIRED} in
234 always)
235 COMMONDEPEND+=" ${qtdeclarativedepend}"
236 ;;
237 optional)
238 IUSE+=" declarative"
239 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
240 ;;
241 *) ;;
242esac
243unset qtdeclarativedepend
244
245# QtHelp dependencies
246qthelpdepend="
247 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
248"
249case ${QTHELP_REQUIRED} in
250 always)
251 COMMONDEPEND+=" ${qthelpdepend}"
252 ;;
253 optional)
254 IUSE+=" qthelp"
255 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
256 ;;
257esac
258unset qthelpdepend
83 259
84# OpenGL dependencies 260# OpenGL dependencies
85qtopengldepend=" 261qtopengldepend="
86 x11-libs/qt-opengl:4 262 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
87" 263"
88case ${OPENGL_REQUIRED} in 264case ${OPENGL_REQUIRED} in
89 always) 265 always)
90 COMMONDEPEND="${COMMONDEPEND} ${qtopengldepend}" 266 COMMONDEPEND+=" ${qtopengldepend}"
91 ;; 267 ;;
92 optional) 268 optional)
93 IUSE="${IUSE} opengl" 269 IUSE+=" opengl"
94 COMMONDEPEND="${COMMONDEPEND}
95 opengl? ( ${qtopengldepend} ) 270 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
96 "
97 ;; 271 ;;
98 *) ;; 272 *) ;;
99esac 273esac
100unset qtopengldepend 274unset qtopengldepend
101 275
276# MultiMedia dependencies
277qtmultimediadepend="
278 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
279"
280case ${MULTIMEDIA_REQUIRED} in
281 always)
282 COMMONDEPEND+=" ${qtmultimediadepend}"
283 ;;
284 optional)
285 IUSE+=" multimedia"
286 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
287 ;;
288 *) ;;
289esac
290unset qtmultimediadepend
291
102# WebKit dependencies 292# WebKit dependencies
293case ${KDE_REQUIRED} in
294 always)
295 qtwebkitusedeps="[kde]"
296 ;;
297 optional)
298 qtwebkitusedeps="[kde?]"
299 ;;
300 *) ;;
301esac
103qtwebkitdepend=" 302qtwebkitdepend="
104 x11-libs/qt-webkit:4 303 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
105" 304"
305unset qtwebkitusedeps
106case ${WEBKIT_REQUIRED} in 306case ${WEBKIT_REQUIRED} in
107 always) 307 always)
108 COMMONDEPEND="${COMMONDEPEND} ${qtwebkitdepend}" 308 COMMONDEPEND+=" ${qtwebkitdepend}"
109 ;; 309 ;;
110 optional) 310 optional)
111 IUSE="${IUSE} webkit" 311 IUSE+=" webkit"
112 COMMONDEPEND="${COMMONDEPEND}
113 webkit? ( ${qtwebkitdepend} ) 312 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
114 "
115 ;; 313 ;;
116 *) ;; 314 *) ;;
117esac 315esac
118unset qtwebkitdepend 316unset qtwebkitdepend
119 317
121cppuintdepend=" 319cppuintdepend="
122 dev-util/cppunit 320 dev-util/cppunit
123" 321"
124case ${CPPUNIT_REQUIRED} in 322case ${CPPUNIT_REQUIRED} in
125 always) 323 always)
126 DEPEND="${DEPEND} ${cppuintdepend}" 324 DEPEND+=" ${cppuintdepend}"
127 ;; 325 ;;
128 optional) 326 optional)
129 IUSE="${IUSE} test" 327 IUSE+=" test"
130 DEPEND="${DEPEND}
131 test? ( ${cppuintdepend} ) 328 DEPEND+=" test? ( ${cppuintdepend} )"
132 "
133 ;; 329 ;;
134 *) ;; 330 *) ;;
135esac 331esac
136unset cppuintdepend 332unset cppuintdepend
137 333
138# DEPRECATED block
139if [[ ${NEED_KDE} != "none" ]]; then
140 # localization deps
141 # DISABLED UNTIL PMS decide correct approach :(
142 if [[ -n ${KDE_LINGUAS} ]]; then
143 LNG_DEP=""
144 for _lng in ${KDE_LINGUAS}; do
145 # there must be or due to issue if lingua is not present in kde-l10n so
146 # it wont die but pick kde-l10n as-is.
147 LNG_DEP="${LNG_DEP}
148 || (
149 kde-base/kde-l10n[linguas_${_lng},kdeprefix=]
150 kde-base/kde-l10n[kdeprefix=]
151 )
152 "
153 done
154 fi
155fi # NEED_KDE != NONE block
156
157# Setup packages inheriting this eclass
158case ${KDEBASE} in
159
160 kde-base)
161 if [[ $BUILD_TYPE = live ]]; then
162 # Disable tests for live ebuilds
163 RESTRICT="${RESTRICT} test"
164 # Live ebuilds in kde-base default to kdeprefix by default
165 IUSE="${IUSE} +kdeprefix"
166 else
167 # All other ebuild types default to -kdeprefix as before
168 IUSE="${IUSE} kdeprefix"
169 fi
170 # Determine SLOT from PV
171 case ${PV} in
172 4.3* | 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) SLOT="4.3" ;;
173 4.2* | 4.1.9* | 4.1.8* | 4.1.7* | 4.1.6*) SLOT="4.2" ;;
174 *9999*) SLOT="live" ;;
175 *) die "Unsupported ${PV}" ;;
176 esac
177 _kdedir="${SLOT}"
178 _pv="-${PV}:${SLOT}"
179 _pvn="-${PV}"
180
181 # Block installation of other SLOTS unless kdeprefix
182 for slot in ${KDE_SLOTS[@]}; do
183 # Block non kdeprefix ${PN} on other slots
184 if [[ ${SLOT} != ${slot} ]]; then
185 RDEPEND="${RDEPEND}
186 !kdeprefix? ( !kde-base/${PN}:${slot}[-kdeprefix] )
187 "
188 fi
189 done
190 ;;
191
192 koffice)
193 SLOT="2"
194 _pv="-${KDE_MINIMAL}"
195 _pvn="${_pv}"
196 ;;
197
198 *)
199 _pv="-${KDE_MINIMAL}"
200 _pvn="${_pv}"
201 ;;
202
203esac
204
205# KDE dependencies 334# KDE dependencies
335# Qt accessibility classes are needed in various places, bug 325461
206kdecommondepend=" 336kdecommondepend="
207 dev-lang/perl 337 dev-lang/perl
338 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
339 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
340 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
341 >=x11-libs/qt-script-${QT_MINIMAL}:4
342 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
343 >=x11-libs/qt-svg-${QT_MINIMAL}:4
344 >=x11-libs/qt-test-${QT_MINIMAL}:4
345 !aqua? (
208 x11-libs/libXext 346 x11-libs/libXext
209 x11-libs/libXt 347 x11-libs/libXt
210 x11-libs/libXxf86vm 348 x11-libs/libXxf86vm
211 x11-libs/qt-core:4[qt3support,ssl] 349 )
212 x11-libs/qt-gui:4[accessibility,dbus]
213 x11-libs/qt-qt3support:4[accessibility]
214 x11-libs/qt-script:4
215 x11-libs/qt-sql:4[qt3support]
216 x11-libs/qt-svg:4
217 x11-libs/qt-test:4
218" 350"
351
219if [[ ${PN} != kdelibs ]]; then 352if [[ ${PN} != kdelibs ]]; then
353 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
220 if [[ ${KDEBASE} = kde-base ]]; then 354 if [[ ${KDEBASE} = kdevelop ]]; then
221 kdecommondepend="${kdecommondepend} 355 if [[ ${PN} != kdevplatform ]]; then
222 kdeprefix? ( >=kde-base/kdelibs${_pv}[kdeprefix] ) 356 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
223 !kdeprefix? ( >=kde-base/kdelibs${_pvn}[-kdeprefix] ) 357 # @DESCRIPTION:
224 " 358 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
225 else 359 # Applies to KDEBASE=kdevelop only.
226 kdecommondepend="${kdecommondepend} 360 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
227 >=kde-base/kdelibs${_pv} 361 case ${KDEVPLATFORM_REQUIRED} in
228 " 362 always)
363 kdecommondepend+="
364 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
365 "
366 ;;
367 *) ;;
368 esac
369 fi
229 fi 370 fi
230fi 371fi
231unset _pv _pvn
232kdedepend=" 372kdedepend="
233 >=dev-util/cmake-2.6.2 373 dev-util/automoc
234 dev-util/pkgconfig 374 dev-util/pkgconfig
235 >=sys-apps/sandbox-1.3.2 375 !aqua? (
376 || ( >=x11-libs/libXtst-1.1.0 <x11-proto/xextproto-7.1.0 )
377 x11-proto/xf86vidmodeproto
378 )
236" 379"
380kderdepend=""
381
382kdehandbookdepend="
383 app-text/docbook-xml-dtd:4.2
384 app-text/docbook-xsl-stylesheets
385"
386kdehandbookrdepend="
387 $(add_kdebase_dep kdelibs 'handbook')
388"
389case ${KDE_HANDBOOK} in
390 always)
391 kdedepend+=" ${kdehandbookdepend}"
392 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
393 ;;
394 optional)
395 IUSE+=" +handbook"
396 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
397 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
398 ;;
399 *) ;;
400esac
401unset kdehandbookdepend kdehandbookrdepend
402
237case ${KDE_REQUIRED} in 403case ${KDE_REQUIRED} in
238 always) 404 always)
239 COMMONDEPEND="${COMMONDEPEND} ${kdecommondepend}" 405 IUSE+=" aqua"
240 DEPEND="${DEPEND} ${kdedepend}" 406 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
407 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
408 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
241 ;; 409 ;;
242 optional) 410 optional)
243 IUSE="${IUSE} kde" 411 IUSE+=" aqua kde"
244 COMMONDEPEND="${COMMONDEPEND} 412 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
245 kde? ( ${kdecommondepend} )" 413 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
246 DEPEND="${DEPEND} 414 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
247 kde? ( ${kdedepend} )"
248 ;; 415 ;;
249 *) ;; 416 *) ;;
250esac 417esac
418
251unset kdecommondepend kdedepend 419unset kdecommondepend kdedepend kderdepend
252 420
253debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}" 421debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
254debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}" 422debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
255debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}" 423debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
256 424
257# Accumulate dependencies set by this eclass 425# Accumulate dependencies set by this eclass
258DEPEND="${DEPEND} ${COMMONDEPEND}" 426DEPEND+=" ${COMMONDEPEND}"
259RDEPEND="${RDEPEND} ${COMMONDEPEND}" 427RDEPEND+=" ${COMMONDEPEND}"
428unset COMMONDEPEND
429
430# Add experimental kdeenablefinal, disabled by default
431IUSE+=" kdeenablefinal"
260 432
261# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 433# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
262# koffice ebuild, the URI should be set in the ebuild itself 434# koffice ebuild, the URI should be set in the ebuild itself
263case ${BUILD_TYPE} in 435case ${BUILD_TYPE} in
264 live) 436 live)
265 SRC_URI="" 437 SRC_URI=""
438 if has subversion ${INHERITED}; then
439 # Determine branch URL based on live type
440 local branch_prefix
441 case ${PV} in
442 9999*)
443 # trunk
444 branch_prefix="trunk/KDE"
445 ;;
446 *)
447 # branch
448 branch_prefix="branches/KDE/${SLOT}"
449 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
450 # @DESCRIPTION
451 # Suffix appended to ESVN_PROJECT depending on fetched branch.
452 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
453 ESVN_PROJECT_SUFFIX="-${PV}"
454 ;;
455 esac
266 # @ECLASS-VARIABLE: ESVN_MIRROR 456 # @ECLASS-VARIABLE: ESVN_MIRROR
267 # @DESCRIPTION: 457 # @DESCRIPTION:
268 # This variable allows easy overriding of default kde mirror service 458 # This variable allows easy overriding of default kde mirror service
269 # (anonsvn) with anything else you might want to use. 459 # (anonsvn) with anything else you might want to use.
270 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde} 460 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
271 # Split ebuild, or extragear stuff 461 # Split ebuild, or extragear stuff
272 if [[ -n ${KMNAME} ]]; then 462 if [[ -n ${KMNAME} ]]; then
273 ESVN_PROJECT="${KMNAME}" 463 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
464 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
465 KMMODULE="${PN}"
466 fi
467 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
468 case ${KMNAME} in
469 kdebase-*)
470 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
471 ;;
472 kdelibs-*)
473 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
474 ;;
475 kdereview*)
476 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
477 ;;
478 kdesupport)
479 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
480 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
481 ;;
482 kde*)
483 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
484 ;;
485 extragear*|playground*)
486 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
487 # build packages from same svn location.
488 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
489 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
490 ;;
491 koffice)
492 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
493 ;;
494 *)
495 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
496 ;;
497 esac
498 else
499 # kdelibs, kdepimlibs
500 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
501 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
502 fi
503 # @ECLASS-VARIABLE: ESVN_UP_FREQ
504 # @DESCRIPTION:
505 # This variable is used for specifying the timeout between svn synces
506 # for kde-base and koffice modules. Does not affect misc apps.
507 # Default value is 1 hour.
508 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
509 elif has git ${INHERITED}; then
274 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then 510 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
275 KMMODULE="${PN}" 511 KMMODULE="${PN}"
276 fi 512 fi
277 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
278 case ${KMNAME} in 513 case ${KDEBASE} in
279 kdebase-*) 514 kdevelop)
280 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/KDE/kdebase/${KMNAME#kdebase-}" 515 EGIT_REPO_URI="git://git.kde.org/${KMMODULE}"
281 ;;
282 kdereview)
283 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
284 ;;
285 kdesupport)
286 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
287 ESVN_PROJECT="${PN}"
288 ;;
289 kde*)
290 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/KDE/${KMNAME}"
291 ;;
292 extragear*|playground*)
293 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
294 # build packages from same svn location.
295 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
296 ESVN_PROJECT="${PN}"
297 ;;
298 koffice)
299 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
300 ;;
301 *)
302 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
303 ;; 516 ;;
304 esac 517 esac
305 else
306 # kdelibs, kdepimlibs
307 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/KDE/${PN}"
308 ESVN_PROJECT="${PN}"
309 fi 518 fi
310 # limit syncing to 1 hour.
311 ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
312 ;; 519 ;;
313 *) 520 *)
314 if [[ -n ${KDEBASE} ]]; then 521 if [[ -n ${KDEBASE} ]]; then
315 if [[ -n ${KMNAME} ]]; then 522 if [[ -n ${KMNAME} ]]; then
316 case ${KMNAME} in 523 case ${KMNAME} in
321 esac 528 esac
322 else 529 else
323 _kmname=${PN} 530 _kmname=${PN}
324 fi 531 fi
325 _kmname_pv="${_kmname}-${PV}" 532 _kmname_pv="${_kmname}-${PV}"
326 if [[ $NEED_KDE != live ]]; then
327 case ${KDEBASE} in 533 case ${KDEBASE} in
328 kde-base) 534 kde-base)
329 case ${PV} in 535 case ${PV} in
330 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) 536 4.[456].8[05] | 4.[456].9[023568])
331 SRC_URI="http://dev.gentooexperimental.org/~alexxy/kde/${PV}/${_kmname_pv}.tar.lzma" ;; 537 # Unstable KDE SC releases
332 4.1.9* | 4.1.8* | 4.1.7* | 4.1.6* | 4.0.9* | 4.0.8*)
333 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 538 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
539 ;;
540 4.4.6 | 4.4.7 | 4.4.8)
541 # Only kdepim here
542 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
543 ;;
544 *)
545 # Stable KDE SC releases
334 *) SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" ;; 546 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
547 ;;
335 esac 548 esac
336 ;; 549 ;;
337 koffice) 550 koffice)
551 case ${PV} in
552 2.1.[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
338 SRC_URI="mirror://kde/unstable/${_kmname_pv}/src/${_kmname_pv}.tar.bz2" 553 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
554 esac
339 ;; 555 ;;
556 kdevelop)
557 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
558 ;;
340 esac 559 esac
341 fi
342 unset _kmname _kmname_pv 560 unset _kmname _kmname_pv
343 fi 561 fi
344 ;; 562 ;;
345esac 563esac
346 564
348 566
349# @ECLASS-VARIABLE: PREFIX 567# @ECLASS-VARIABLE: PREFIX
350# @DESCRIPTION: 568# @DESCRIPTION:
351# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 569# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
352# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 570# kde-base packages go into KDE4 installation directory (KDEDIR) by default.
353# No matter the PREFIX, package will be built agains KDE installed in KDEDIR. 571# No matter the PREFIX, package will be built against KDE installed in KDEDIR.
354 572
355# @FUNCTION: kde4-base_pkg_setup 573# @FUNCTION: kde4-base_pkg_setup
356# @DESCRIPTION: 574# @DESCRIPTION:
357# Do the basic kdeprefix KDEDIR settings and determine with which kde should 575# Do the basic kdeprefix KDEDIR settings and determine with which kde should
358# optional applications link 576# optional applications link
359kde4-base_pkg_setup() { 577kde4-base_pkg_setup() {
360 debug-print-function ${FUNCNAME} "$@" 578 debug-print-function ${FUNCNAME} "$@"
361 579
580 # Prefix compat:
581 if [[ ${EAPI} == 2 ]] && ! use prefix; then
582 EPREFIX=
583 EROOT=${ROOT}
584 fi
585
586 # Append missing trailing slash character
587 [[ ${EROOT} = */ ]] || EROOT+="/"
588
362 # QA ebuilds 589 # QA ebuilds
363 case ${NEED_KDE} in
364 none) ewarn "QA Notice: using deprecated NEED_KDE variable, use KDE_REQUIRED=\"never\" or KDE_REQUIRED=\"optional\" instead. You may want to override KDE_MINIMAL as well (default is KDE_MINIMAL=\"${KDE_MINIMAL}\")." ;;
365 *) [[ -n ${NEED_KDE} ]] && ewarn "QA Notice: using deprecated NEED_KDE variable, use KDE_MINIMAL instead (default is KDE_MINIMAL=\"${KDE_MINIMAL}\")." ;;
366 esac
367 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})." 590 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})."
368 591
369 # Don't set KDEHOME during compilation, it will cause access violations 592 # Don't set KDEHOME during compilation, it will cause access violations
370 unset KDEHOME 593 unset KDEHOME
371 594
372 if [[ ${KDEBASE} = kde-base ]]; then 595 if [[ ${KDEBASE} = kde-base ]]; then
373 if use kdeprefix; then 596 if use kdeprefix; then
374 KDEDIR="/usr/kde/${_kdedir}" 597 KDEDIR=/usr/kde/${SLOT}
375 else 598 else
376 KDEDIR="/usr" 599 KDEDIR=/usr
377 fi 600 fi
378 PREFIX="${PREFIX:-${KDEDIR}}" 601 : ${PREFIX:=${KDEDIR}}
379 else 602 else
380 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL 603 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
381 KDEDIR= 604 KDEDIR=
382 local kde_minimal_met 605 local kde_minimal_met
383 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do 606 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
384 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1 607 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
385 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then 608 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
386 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then 609 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
387 KDEDIR="/usr/kde/${slot}" 610 KDEDIR=/usr/kde/${slot}
388 else 611 else
389 KDEDIR="/usr" 612 KDEDIR=/usr
390 fi 613 fi
391 break; 614 break;
392 fi 615 fi
393 done 616 done
617 unset slot
618
619 # Bail out if kdelibs required but not found
620 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
394 [[ -z KDEDIR ]] && die "Failed to determine KDEDIR!" 621 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
395 PREFIX="${PREFIX:-/usr}" 622 else
623 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
396 fi 624 fi
397 625
398 # Not needed anymore 626 : ${PREFIX:=/usr}
399 unset _kdedir
400
401 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
402 echo
403 elog "WARNING! This is an experimental live ebuild of ${KMNAME:-${PN}}"
404 elog "Use it at your own risk."
405 elog "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
406 echo
407 fi 627 fi
628 EKDEDIR=${EPREFIX}${KDEDIR}
629
630 # Point pkg-config path to KDE *.pc files
631 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
632 # Point to correct QT plugins path
633 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/"
634
635 # Fix XDG collision with sandbox
636 export XDG_CONFIG_HOME="${T}"
408} 637}
409 638
410# @FUNCTION: kde4-base_src_unpack 639# @FUNCTION: kde4-base_src_unpack
411# @DESCRIPTION: 640# @DESCRIPTION:
412# This function unpacks the source tarballs for KDE4 applications. 641# This function unpacks the source tarballs for KDE4 applications.
413kde4-base_src_unpack() { 642kde4-base_src_unpack() {
414 debug-print-function ${FUNCNAME} "$@" 643 debug-print-function ${FUNCNAME} "$@"
415 644
416 if [[ ${BUILD_TYPE} = live ]]; then 645 if [[ ${BUILD_TYPE} = live ]]; then
646 if has subversion ${INHERITED}; then
417 migrate_store_dir 647 migrate_store_dir
418 subversion_src_unpack 648 subversion_src_unpack
649 elif has git ${INHERITED}; then
650 git_src_unpack
651 fi
652 elif [[ ${EAPI} == 2 ]]; then
653 local file
654 for file in ${A}; do
655 # This setup is because EAPI <= 2 cannot unpack *.tar.xz files
656 # directly, so we do it ourselves (using the exact same code as portage)
657 case ${file} in
658 *.tar.xz)
659 echo ">>> Unpacking ${file} to ${PWD}"
660 xz -dc "${DISTDIR}"/${file} | tar xof -
661 assert "failed unpacking ${file}"
662 ;;
663 *)
664 unpack ${file}
665 ;;
666 esac
667 done
419 else 668 else
420 base_src_unpack 669 # For EAPI >= 3, we can just use unpack() directly
670 unpack ${A}
421 fi 671 fi
422} 672}
423 673
424# @FUNCTION: kde4-base_src_compile 674# @FUNCTION: kde4-base_src_prepare
425# @DESCRIPTION: 675# @DESCRIPTION:
426# General pre-configure and pre-compile function for KDE4 applications. 676# General pre-configure and pre-compile function for KDE4 applications.
427# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and 677# It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
678# enable_selected_linguas() and enable_selected_doc_linguas()
428# enable_selected_linguas() in kde4-functions.eclass(5) for further details. 679# in kde4-functions.eclass(5) for further details.
429kde4-base_src_prepare() { 680kde4-base_src_prepare() {
430 debug-print-function ${FUNCNAME} "$@" 681 debug-print-function ${FUNCNAME} "$@"
431 682
432 # Only enable selected languages, used for KDE extragear apps. 683 # Only enable selected languages, used for KDE extragear apps.
433 if [[ -n ${KDE_LINGUAS} ]]; then 684 if [[ -n ${KDE_LINGUAS} ]]; then
434 enable_selected_linguas 685 enable_selected_linguas
435 fi 686 fi
436 687
688 # Enable/disable handbooks for kde4-base packages
689 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
690 # kdelibs inherits kde4-base but handle installing the handbook itself
691 if ! has kde4-meta ${INHERITED}; then
692 has handbook ${IUSE//+} && [[ ${PN} != kde-l10n ]] && [[ ${PN} != kdelibs ]] && enable_selected_doc_linguas
693 fi
694
695 # SCM bootstrap
696 if [[ ${BUILD_TYPE} = live ]]; then
697 if has subversion ${INHERITED}; then
698 subversion_src_prepare
699 elif has git ${INHERITED}; then
700 git_src_prepare
701 fi
702 fi
703
704 # Apply patches
437 base_src_prepare 705 base_src_prepare
438 706
439 # Save library dependencies 707 # Save library dependencies
440 if [[ -n ${KMSAVELIBS} ]] ; then 708 if [[ -n ${KMSAVELIBS} ]] ; then
441 save_library_dependencies 709 save_library_dependencies
443 711
444 # Inject library dependencies 712 # Inject library dependencies
445 if [[ -n ${KMLOADLIBS} ]] ; then 713 if [[ -n ${KMLOADLIBS} ]] ; then
446 load_library_dependencies 714 load_library_dependencies
447 fi 715 fi
716
717 # Replace KDE4Workspace library targets
718 find "${S}" -name CMakeLists.txt \
719 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
720 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
721 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
722 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
723 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
724 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
725 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
726 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
727 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
728 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
729 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
730 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
731 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
732 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
733 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
734 || die 'failed to replace KDE4Workspace library targets'
735
736 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
737 if [[ -z ${KDEBASE} ]]; then
738 find "${S}" -name "*.docbook" \
739 -exec sed -i -r \
740 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
741 || die 'failed to fix DocBook variant version'
742 fi
448} 743}
449 744
450# @FUNCTION: kde4-base_src_configure 745# @FUNCTION: kde4-base_src_configure
451# @DESCRIPTION: 746# @DESCRIPTION:
452# Function for configuring the build of KDE4 applications. 747# Function for configuring the build of KDE4 applications.
453kde4-base_src_configure() { 748kde4-base_src_configure() {
454 debug-print-function ${FUNCNAME} "$@" 749 debug-print-function ${FUNCNAME} "$@"
455 750
751 # Build tests in src_test only, where we override this value
752 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
753
754 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
755 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
756 fi
757
758 if has debug ${IUSE//+} && use debug; then
759 # Set "real" debug mode
760 CMAKE_BUILD_TYPE="Debugfull"
761 else
456 # Handle common release builds 762 # Handle common release builds
457 if ! has debug ${IUSE//+} || ! use debug; then
458 append-cppflags -DQT_NO_DEBUG 763 append-cppflags -DQT_NO_DEBUG
459 fi 764 fi
460 765
461 # Build tests in src_test only, where we override this value
462 local cmakeargs="-DKDE4_BUILD_TESTS=OFF"
463
464 # Set distribution name 766 # Set distribution name
465 [[ ${PN} = kdelibs ]] && cmakeargs="${cmakeargs} -DKDE_DISTRIBUTION_TEXT=Gentoo" 767 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
466 768
467 # Here we set the install prefix 769 # Here we set the install prefix
468 cmakeargs="${cmakeargs} -DCMAKE_INSTALL_PREFIX=${PREFIX}" 770 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
469 771
470 # Set environment 772 # Use colors
471 QTEST_COLORED=1 773 QTEST_COLORED=1
472 QT_PLUGIN_PATH="${KDEDIR}/$(get_libdir)/kde4/plugins/"
473
474 # Hardcode path to *.pc KDE files
475 export PKG_CONFIG_PATH="${PKG_CONFIG_PATH:+${PKG_CONFIG_PATH}:}${KDEDIR}/$(get_libdir)/pkgconfig"
476 774
477 # Shadow existing /usr installations 775 # Shadow existing /usr installations
478 unset KDEDIRS 776 unset KDEDIRS
479 777
480 # Override some environment variables - only when kdeprefix is different, 778 # Handle kdeprefix-ed KDE
481 # to not break ccache/distcc
482 if [[ ${KDEDIR} != /usr ]]; then 779 if [[ ${KDEDIR} != /usr ]]; then
780 # Override some environment variables - only when kdeprefix is different,
781 # to not break ccache/distcc
483 PATH="${KDEDIR}/bin:${PATH}" 782 PATH="${EKDEDIR}/bin:${PATH}"
484 LDPATH="${KDEDIR}/$(get_libdir):${LDPATH}"
485 fi
486 783
487 if has kdeprefix ${IUSE//+} && use kdeprefix; then 784 # Append library search path
785 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
786
787 # Append full RPATH
788 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
789
488 # Set cmake prefixes to allow buildsystem to localize valid KDE installation 790 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
489 # when more are present 791 # when more are present
490 cmakeargs="${cmakeargs} -DCMAKE_SYSTEM_PREFIX_PATH=${KDEDIR}" 792 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
491 else 793 fi
794
795 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
796 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4)
797 #kde-config -path data unavailable when cross-compiling
798 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
799
800 # Handle kdeprefix in application itself
801 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
492 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 802 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc
493 cmakeargs="${cmakeargs} -DSYSCONF_INSTALL_DIR=/etc" 803 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
494 fi 804 fi
495 805
806 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
807 mycmakeargs=(${mycmakeargs})
808 fi
809
496 mycmakeargs="${cmakeargs} ${mycmakeargs}" 810 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
497 811
498 cmake-utils_src_configure 812 cmake-utils_src_configure
499} 813}
500 814
501# @FUNCTION: kde4-base_src_compile 815# @FUNCTION: kde4-base_src_compile
502# @DESCRIPTION: 816# @DESCRIPTION:
503# General function for compiling KDE4 applications. 817# General function for compiling KDE4 applications.
504kde4-base_src_compile() { 818kde4-base_src_compile() {
505 debug-print-function ${FUNCNAME} "$@" 819 debug-print-function ${FUNCNAME} "$@"
506 820
507 cmake-utils_src_compile 821 cmake-utils_src_compile "$@"
508} 822}
509 823
510# @FUNCTION: kde4-base_src_test 824# @FUNCTION: kde4-base_src_test
511# @DESCRIPTION: 825# @DESCRIPTION:
512# Function for testing KDE4 applications. 826# Function for testing KDE4 applications.
513kde4-base_src_test() { 827kde4-base_src_test() {
514 debug-print-function ${FUNCNAME} "$@" 828 debug-print-function ${FUNCNAME} "$@"
515 829
516 # Override this value, set in kde4-base_src_configure() 830 # Override this value, set in kde4-base_src_configure()
517 mycmakeargs="${mycmakeargs} -DKDE4_BUILD_TESTS=ON" 831 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
518 cmake-utils_src_configure 832 cmake-utils_src_configure
519 kde4-base_src_compile 833 kde4-base_src_compile
520 834
835 if [[ ${VIRTUALX_REQUIRED} == always ]] ||
836 ( [[ ${VIRTUALX_REQUIRED} != manual ]] && use test ); then
837
838 if [[ ${maketype} ]]; then
839 # surprise- we are already INSIDE virtualmake!!!
840 ewarn "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
841 ewarn " You may NOT set maketype or call virtualmake from the ebuild. Applying workaround."
842 cmake-utils_src_test
843 else
844 export maketype="cmake-utils_src_test"
845 virtualmake
846 fi
847 else
521 cmake-utils_src_test 848 cmake-utils_src_test
849 fi
522} 850}
523 851
524# @FUNCTION: kde4-base_src_install 852# @FUNCTION: kde4-base_src_install
525# @DESCRIPTION: 853# @DESCRIPTION:
526# Function for installing KDE4 applications. 854# Function for installing KDE4 applications.
527kde4-base_src_install() { 855kde4-base_src_install() {
528 debug-print-function ${FUNCNAME} "$@" 856 debug-print-function ${FUNCNAME} "$@"
529 857
858 # Prefix support, for usage in ebuilds
859 if [[ ${EAPI} == 2 ]] && ! use prefix; then
860 ED=${D}
861 fi
862
530 if [[ -n ${KMSAVELIBS} ]] ; then 863 if [[ -n ${KMSAVELIBS} ]] ; then
531 install_library_dependencies 864 install_library_dependencies
532 fi 865 fi
533 866
534 kde4-base_src_make_doc 867 # Install common documentation of KDE4 applications
868 local doc
869 if ! has kde4-meta ${INHERITED}; then
870 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
871 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
872 done
873 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
874 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
875 done
876 fi
877
535 cmake-utils_src_install 878 cmake-utils_src_install
536}
537
538# @FUNCTION: kde4-base_src_make_doc
539# @DESCRIPTION:
540# Function for installing the documentation of KDE4 applications.
541kde4-base_src_make_doc() {
542 debug-print-function ${FUNCNAME} "$@"
543
544 local doc
545 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
546 [[ -s ${doc} ]] && dodoc ${doc}
547 done
548
549 if [[ -z ${KMNAME} ]]; then
550 for doc in {apps,runtime,workspace,.}/*/{AUTHORS,README*}; do
551 if [[ -s ${doc} ]]; then
552 local doc_complete=${doc}
553 doc="${doc#*/}"
554 newdoc "$doc_complete" "${doc%/*}.${doc##*/}"
555 fi
556 done
557 fi
558
559 if [[ -n ${KDEBASE} ]] && [[ -d "${D}/usr/share/doc/${PF}" ]]; then
560 # work around bug #97196
561 dodir /usr/share/doc/KDE4 && \
562 mv "${D}/usr/share/doc/${PF}" "${D}"/usr/share/doc/KDE4/ || \
563 die "Failed to move docs to KDE4/."
564 fi
565} 879}
566 880
567# @FUNCTION: kde4-base_pkg_postinst 881# @FUNCTION: kde4-base_pkg_postinst
568# @DESCRIPTION: 882# @DESCRIPTION:
569# Function to rebuild the KDE System Configuration Cache after an application has been installed. 883# Function to rebuild the KDE System Configuration Cache after an application has been installed.
570kde4-base_pkg_postinst() { 884kde4-base_pkg_postinst() {
571 debug-print-function ${FUNCNAME} "$@" 885 debug-print-function ${FUNCNAME} "$@"
572 886
573 buildsycoca 887 buildsycoca
888
889 if [[ ${BUILD_TYPE} = live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
890 echo
891 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
892 einfo "Use it at your own risk."
893 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
894 echo
895 elif [[ ${BUILD_TYPE} != live ]] && [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && has kdeprefix ${IUSE//+} && use kdeprefix; then
896 # warning about kdeprefix for non-live users
897 echo
898 ewarn "WARNING! You have the kdeprefix useflag enabled."
899 ewarn "This setting is strongly discouraged and might lead to potential trouble"
900 ewarn "with KDE update strategies."
901 ewarn "You are using this setup at your own risk and the kde team does not"
902 ewarn "take responsibilities for dead kittens."
903 echo
904 fi
905 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && ! has_version 'kde-base/kdebase-runtime-meta' && ! has_version 'kde-base/kdebase-startkde'; then
906 # warn about not supported approach
907 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
908 echo
909 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
910 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
911 ewarn "With this setting you are unsupported by KDE team."
912 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
913 fi
914 fi
574} 915}
575 916
576# @FUNCTION: kde4-base_pkg_postrm 917# @FUNCTION: kde4-base_pkg_postrm
577# @DESCRIPTION: 918# @DESCRIPTION:
578# Function to rebuild the KDE System Configuration Cache after an application has been removed. 919# Function to rebuild the KDE System Configuration Cache after an application has been removed.

Legend:
Removed from v.1.35  
changed lines
  Added in v.1.79

  ViewVC Help
Powered by ViewVC 1.1.20